<:
  use Time::Local;

  @month = ('dummy','Januar','Februar','Mrz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember');
  @day = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');

  # Monat - Jahr
  $layout_month = '<div style="padding-top: 10px;"></div>\
<table class="dates" width="100%%" border="0" cellpadding="0" cellspacing="0">\
<tr><th align="left" colspan="2" bgcolor="#80CCF8"><strong>&nbsp;%s %d</strong></th>\
<td align="left" bgcolor="#80CCF8">Ort</td>\
<td align="center" bgcolor="#80CCF8">Zeit</td>\
</tr>';
  # bgcol Tag (Tag) - Text - Ort - Zeit
  $layout_row = '\
<tr bgcolor=#%s>\
  <td align=left width=20%%>&nbsp;%d. (%s)</td>\
  <td align=left width=60%%>%s</td>\
  <td align=left width=15%%>%s</td>\
  <td align=right width=5%%>%s&nbsp;</td>\
</tr>';
  $layout_foot = '\
</table>';
  @layout_color = ('ffffff','eff0f1');
:>

<define-tag more_years>
<:

  my @y;
  my $max = (localtime(time - 30*24*60*60))[5]+1900;
  foreach my $year (2000..$max) {
    push (@y, sprintf ("<a href=\"%s.%s\">%s</a>",
    $year, $year >= 2008?"php":"html", $year))
      if ($year ne "<get-var WML_SRC_BASENAME>");
  }	
  printf "<p>Vergangene Termine in %s</p>\n", join (", ", @y);
:>
</define-tag>

<define-tag build_tables>
<:
  $mon = 0;
  $year = (split (/-/, (split (/\|/, (sort (@termine))[0]))[0]))[0];
  $descr = "";
  $day = 0;
  $color = $layout_color[1];
  foreach $termin (sort (@termine)) {
    @termin = split (/\|/, $termin);
    @date = split (/-/, $termin[0]);

    if ($mon ne "$date[0]-$date[1]") {
      if ($mon != 0) {
        print $layout_foot;
	$descr = "";
	$day = 0;
	$color = $layout_color[1];
	print "<p><hr>" if ($year != $date[0]);
	$year = $date[0];
      }
      printf $layout_month, $month[$date[1]], $date[0];
      $mon = "$date[0]-$date[1]";
    }
    if ($termin[2] ne $descr || $date[2] != $day+1) {
      $color = $color eq $layout_color[0]?$layout_color[1]:$layout_color[0];
      $descr = $termin[2];
    }
    $day = $date[2];
    if ($termin[4]) {
      $text = sprintf ("<a href=\"%s\">%s</a>", $termin[4], $termin[2]);
    } else {
      $text = $termin[2];
    }
    $wday = (localtime(timelocal(0,0,0,$date[2],$date[1]-1, $date[0])))[6];

    printf $layout_row, $color, $date[2], $day[$wday], $text, $termin[3], $termin[1];
  }
  print $layout_foot;

:>
</define-tag>

<define-tag php_utils>
<?
function readdb($datedb)
{
  $dates = array();

  if (($db = fopen($datedb,'r')) !== false) {
    $lines = array();
    while (!feof($db)) {
      $line = fgets($db, 200);

      if (!preg_match("/^([0-9]{4})-([0-9]{2})-([0-9]{2})\|/", $line))
	continue;

      $dates[] = $line;
    }
  }
  return $dates;
}

function display_dates($past=false)
{
  global $dates;

<protect>
  $layout_head = '<div style="padding-top: 10px;"></div>'
		.'<table class="dates" width="100%%" border="0" cellpadding="0" cellspacing="0">'
		.'<tr bgcolor="#aeaeae"><th align="left" colspan="2"><strong>&nbsp;%s</strong></th>'
		.'<td align="left">Ort</td>'
		.'<td align="center">Zeit</td>'
		.'</tr>';
  $layout_row = '<tr bgcolor=#%s>'
	       .'<td align=left width=20%%>&nbsp;%d. (%s)</td>'
	       .'<td align=left width=60%%>%s</td>'
	       .'<td align=left width=15%%>%s</td>'
	       .'<td align=right width=5%%>%s&nbsp;</td>'
	       .'</tr>';
</protect>
  $layout_foot = '</table>';

  $nowstring = date("Y-m-");
  $today = mktime(0,0,0, date('m'), date('d'), date('Y'));

  sort($dates);
  $cmon = false;
  $color = 'ffffff';
  foreach ($dates as $line) {
    if (($past == false && $line < $nowstring) ||
        ($past == true && $line > $nowstring))
      continue;

    if (preg_match("/([0-9]{4})-([0-9]{2})-([0-9]{2})\|([^\|]*)\|[^\|]*\|([^\|]*)\|([^\|]*)\|(.*)/", $line, $match)) {

      $when = mktime(0,0,0, $match[2], $match[3], $match[1]);

      if ($match[1] !== $thisyear || $match[2] !== $thismonth) {
        if ($cmon)
	  echo $layout_foot;
        $thisyear = $match[1];
        $thismonth = $match[2];
	printf($layout_head, strftime("%B %Y", $when));
	$cmon = true;
      }
      if (strlen($match[7]))
	$title = '<a href="' . $match[7] . '">' . $match[5] . '</a>';
      else
	$title = $match[5];

      if ($when == $today)
        $color = 'ffff00';
      printf($layout_row, $color, $match[3], strftime("%A", $when), $title, $match[6], $match[4]);
      $color = $color == 'ffffff'?'d7d7d7':'ffffff';
    }
  }
  if ($cmon)
    echo $layout_foot;
}
?>
</define-tag>

# Local variables:
# mode: indented-text
# mode: auto-fill
# end:
